api/urls.py
from django.urls import path
from . import views

app_name = 'api'

urlpatterns = [
    path('sessions/<slug:session_key>/', views.Sessions.as_view(), name='api-sessions'),
    path('surveys/<int:survey_id>/', views.Surveys.as_view(), name='api-surveys'),
]

framework/urls.py
from django.contrib import admin
from django.urls import path, include
from accounts import views as account_views
from django.contrib.auth import views as auth_views
from django.conf.urls.i18n import i18n_patterns
from . import settings
from django.conf.urls.static import static

urlpatterns = [
    path('i18n/', include('django.conf.urls.i18n')),
    path('admin/', admin.site.urls, name='admin'),
    # path('register/', account_views.register, name='register'),
    path('login/', auth_views.LoginView.as_view(template_name='accounts/login.html'), name='login'),
    path('logout/', auth_views.LogoutView.as_view(template_name='accounts/logout.html'), name='logout'),
    path('api/', include('api.urls', namespace='api')),

    # path('surveys/', include('surveys.urls', namespace='surveys')),
    # Installed apps
    path('tinymce/', include('tinymce.urls')),

]

urlpatterns += i18n_patterns(
    path('surveys/', include('surveys.urls', namespace='surveys')),
    path('', include('home.urls', namespace='home')),
)

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

home/urls.py
from django.urls import path
from . import views
from django.contrib.auth.decorators import login_required


app_name = 'home'

urlpatterns = [
    path('', views.home, name='index'),
    path('post/new/', login_required(views.PostCreateView.as_view()), name='new-post'),
    path('post/<int:pk>/update/', login_required(views.PostUpdateView.as_view()), name="update-post")
]

surveys/urls.py
from django.urls import path
from surveys.views import SurveysView, SurveyUptateView
from . import views
from django.contrib.auth.decorators import login_required

app_name = 'surveys'

urlpatterns = [
    path('', SurveysView.as_view(), name='surveys'),
    path('<int:pk>/', views.survey_detail, name='survey'),
    path('new/', login_required(views.create_survey), name='create-survey'),
    path('<int:pk>/delete/', login_required(views.delete_survey), name='delete-survey'),
    path('<int:pk>/edit/', login_required(SurveyUptateView.as_view()), name='edit-survey'),
    path('<int:pk>/delete-sessions/', login_required(views.delete_sessions), name='delete-sessions'),

    path('<int:survey_id>/introduction/', views.introduction, name='introduction'),
    path('<int:survey_id>/load/', views.load_set, name='load-survey'),
    path('<int:survey_id>/<slug:session_key>/', views.session_detail, name='session'),
    path('<int:survey_id>/<slug:session_key>/instructions/', views.instructions, name='instructions'),

    path('<int:survey_id>/<slug:session_key>/survey/ready/', views.survey_ready, name='survey-ready'),
    path('<int:survey_id>/<slug:session_key>/block/ready/', views.block_ready, name='block-ready'),

    path('<int:survey_id>/<slug:session_key>/trial/', views.trial, name='trial'),
    path('<int:survey_id>/<slug:session_key>/trial/save/<int:trial_id>/', views.save_trial, name='save-trial'),

    path('<int:survey_id>/<slug:session_key>/training/', views.training, name='training'),
    path('<int:survey_id>/<slug:session_key>/save-training/', views.save_training, name='save-training'),

    path('<int:survey_id>/<slug:session_key>/end/', views.end, name='end'),

]

surveys/models.py
from django.db import models
from tinymce.models import HTMLField
from django.urls import reverse
from django.conf import settings

# Redirect constant
REDIRECTS = (
(0, 'Pre'),
(1, 'Intermediate'),
(2, 'Post')
)

# Survey model
class Survey(models.Model):
    name = models.CharField(
        max_length=255,
        verbose_name='The surveys name',
        help_text="Give survey a name"
    )

    description = models.TextField(
        verbose_name='Short description of the survey',
        help_text='Give the survey a short description, so that others know what it us'
    )

    date_created = models.DateTimeField(auto_now_add=True)
    date_modified = models.DateTimeField(auto_now=True)
    introduction = HTMLField(blank=True)
    ready = HTMLField(blank=True)
    end = HTMLField(blank=True)
    ntrials = models.IntegerField(default=1, verbose_name='Trial multiplicator')
    ntraining = models.IntegerField(default=3, verbose_name='Training number')
    user = models.ForeignKey(settings.AUTH_USER_MODEL,on_delete=models.SET_DEFAULT, default=1)

    # Returns name in the admin panel
    def __str__(self):
        return self.name

    # Defines redirect url for generic views
    def get_absolute_url(self):
        return reverse('surveys:survey', kwargs={'pk':self.pk})

# Session model
class Session(models.Model):
    key = models.CharField(max_length=255, primary_key=True)

    survey = models.ForeignKey(
        Survey,
        on_delete=models.CASCADE,
        verbose_name='Related survey')

    start_date = models.DateTimeField(auto_now_add=True)
    end_date = models.DateTimeField(auto_now=True)
    ip_address = models.GenericIPAddressField(
        protocol = 'both',
        unpack_ipv4=True
    )
    participantID = models.IntegerField(null=True)
    comment = models.TextField(null=True)

    # Returns name in the admin panel
    def __str__(self):
        return str(self.key)

    class Meta:
        ordering = ['-start_date']

# Trial model
class Trial(models.Model):
    sessionkey = models.ForeignKey(Session, on_delete=models.CASCADE)
    blockcounter = models.IntegerField(null=True)

    def __str__(self):
        return str(self.id)

    class Meta:
        ordering = ['id']

#Redirect model
class Redirect(models.Model):
    survey = models.ForeignKey(Survey, on_delete=models.CASCADE)
    url = models.URLField(verbose_name='Redirect URL', max_length=255)
    purpose = models.IntegerField(verbose_name="Purpose", choices=REDIRECTS)

    # Returns name in the admin panel
    def __str__(self):
        return str(self.url)

    class Meta:
        ordering = ['purpose']

# Model for a specific factor set
class SetFactor(models.Model):
    survey = models.ForeignKey(Survey, on_delete=models.CASCADE)
    name = models.CharField(max_length=255, verbose_name="Factor name")
    blockfactor = models.BooleanField(verbose_name="Block factor")
    slug = models.SlugField(verbose_name='Factor slug')

    # Returns name in the admin panel
    def __str__(self):
        return str(self.name)

# Model for level of a factor set
class SetLevel(models.Model):
    set_factor = models.ForeignKey(SetFactor, on_delete=models.CASCADE)
    name = models.CharField(max_length=255, verbose_name="Factor Name")
    value = models.IntegerField(verbose_name="Factor value")
    slug = models.SlugField(verbose_name='Level slug')

    # Returns name in the admin panel
    def __str__(self):
        return str(self.name + ' [' + str(self.value) + ']')

surveys/forms.py
from django import forms
from .models import Survey, Session

# Form for creating a Survey
class SurveyCreateFrom(forms.ModelForm):
    class Meta:
        model = Survey
        fields = [
            'name',
            'description',
            'introduction',
            'ready',
        ]
# Form for saving a participants ID and comment at the end of the survey
class ParticipantIDForm(forms.ModelForm):
    class Meta:
        model = Session
        fields = [
            'participantID',
            'comment'
        ]

surveys/views.py
from django.shortcuts import render, get_object_or_404, redirect, HttpResponse, reverse
from django.views import generic
from django.contrib import messages
from django.contrib.auth.mixins import LoginRequiredMixin
from django.core.exceptions import ObjectDoesNotExist
from django.http import HttpRequest
from django.core.exceptions import PermissionDenied
from django.utils.translation import get_language
from .set import Set, showSet
from .models import Survey, Session, Redirect, SetFactor, SetLevel, Trial
from .forms import SurveyCreateFrom, ParticipantIDForm
from rest_framework.views import APIView
from rest_framework.response import Response
from django.db.models import Avg,Sum

import urllib.parse
from itertools import islice
import random

import pickle
import json
import os


# Generic survey view displaying a list of all surveys
class SurveysView(LoginRequiredMixin,generic.ListView):
    model = Survey


# Generic update view for surveys
class SurveyUptateView(LoginRequiredMixin, generic.UpdateView):
    model = Survey
    fields = [
        'name',
        'description',
        'introduction',
        'ready',
        'end'
    ]


# Generic detail view for a Surveys
def survey_detail(request, pk):
    survey = get_object_or_404(Survey, pk=pk)

    trials = Trial.objects.filter(sessionkey__survey=survey)
    ntrials = len(trials)


    context = {
        'survey': survey,
        'ntrials': ntrials
    }

    return render(request, 'surveys/survey_detail.html', context)

# Generates detailed view of sessions
def session_detail(request, survey_id, session_key):
    survey = get_object_or_404(Survey, pk=survey_id)
    session = get_object_or_404(Session, key=session_key)

    # Gets all trials for that the requested session
    trials = Trial.objects.filter(sessionkey=session)


    context = {
        'survey': survey,
        'session': session,
    }
    return render(request, 'surveys/session_detail.html', context)


# Generic create view to create a new survey
def create_survey(request):
    if request.method == 'POST':
        form = SurveyCreateFrom(request.POST or None)
        if form.is_valid():
            instance = form.save(commit=False)
            # Links current user to the survey on creation
            instance.user = request.user
            instance.save()
            messages.success(request, 'New survey successfully created.')
            return redirect('surveys:survey', pk=instance.id )
    else:
        form = SurveyCreateFrom()
        context = {
            'form': form
        }
    return render(request, 'surveys/survey_form.html', context)

# View function that deletes a survey
def delete_survey(request, pk):
    survey = get_object_or_404(Survey, pk=pk)

    # Checks if user can delete the survey
    if survey.user != request.user:
        raise PermissionDenied

    if request.method == 'POST':
        survey.delete()
        messages.success(request, 'Survey successfully deleted')
        return redirect('surveys:surveys')

# Deletes all sessions in a survey
def delete_sessions(request, pk):
    survey = get_object_or_404(Survey, pk=pk)

    if survey.user != request.user:
        raise PermissionDenied

    Session.objects.filter(survey=survey).all().delete()
    messages.success(request, 'Sessions deleted')
    return redirect('surveys:survey', pk=pk)

# Returns survey start screen
def introduction(request, survey_id):
    survey = get_object_or_404(Survey, pk=survey_id)

    # if there is a redirect, redirect
    try:
        redirect_url = survey.redirect_set.get(purpose=0).url

    # else set redirect to None
    except ObjectDoesNotExist:
        redirect_url = None

    context = {
        'survey': survey,
        'redirect': redirect_url,
    }

    return render(request, 'surveys/introduction.html', context)

# Loads sets through ajax call while start_survey.html is loading
def load_set(request, survey_id):
    survey = get_object_or_404(Survey, pk=survey_id)
    language = get_language()

    #Gets trial multiplicator and training count
    ntrials = survey.ntrials
    ntraining = survey.ntraining

    # Get blockfactors for survey and store them in a list
    blockfactors = SetFactor.objects.filter(survey=survey, blockfactor=True)
    blockfactors_list = []
    for blockfactor in blockfactors:
        blockfactors_list.append(list(SetLevel.objects.filter(set_factor=blockfactor)))

    # Get trialfactors for survey and store them in a list
    trialfactors = SetFactor.objects.filter(survey=survey, blockfactor=False)
    trialfactors_list =[]
    for trialfactor in trialfactors:
        trialfactors_list.append(list(SetLevel.objects.filter(set_factor=trialfactor)))

    # if there are any trial factors, create set
    if trialfactors or blockfactors:
        set = Set(blockfactors_list, trialfactors_list, ntrials, ntraining)
        print(set)
    else:
        response = HttpResponse('Ressource <Set> could not be found', status=404)
        return response

    # Flushes session and create new one
    request.session.flush()
    request.session.create()

    # Saves session with session information
    session_key = request.session.session_key
    client_ip = get_ip(request)
    session = Session(survey=survey, key=session_key, ip_address=client_ip)
    session.save()

    #saves set to pickle to ensure object persistency
    try:
        with open('sessions/set_'+session.key, 'wb') as f:
            pickle.dump(set, f)
    except:
        return render(request, 'surveys/error.html', {'error_message':'Session not found, sorry', 'survey': survey})

    # data that is returned to ajax call
    data = {}
    data['session_key'] = session.key
    data['language'] = language
    data['ipaddress'] =  session.ip_address
    print("got here")
    return HttpResponse(json.dumps(data), content_type='application/json')

# Renders screen before trials start.
def instructions(request, survey_id, session_key):
    survey = get_object_or_404(Survey, pk=survey_id)
    session = get_object_or_404(Session, key=session_key)

    # If session key is not current users session key, raise error
    if session.key != request.session.session_key:
        return render(request, 'surveys/error.html', {'error_message': 'Wrong session key', 'session':session, 'survey':survey})

    context = {
        'survey': survey,
        'session': session,
    }

    return render(request, 'surveys/instructions.html', context )

def training(request, survey_id, session_key):
    survey = get_object_or_404(Survey, pk=survey_id)
    session = get_object_or_404(Session, key=session_key)
    language = get_language()

    # If session key is not current users session key, raise error
    if session.key != request.session.session_key:
        error_message = "Wrong session key"
        return render(request, 'surveys/error.html', {'error_message': error_message, 'session':session, 'survey':survey})

    # Open set through pockle
    try:
        with open('sessions/set_'+session.key, 'rb') as f:
            set = pickle.load(f)
    except:
        return render(request, 'surveys/error.html', {'error_message':'Session not found, sorry', 'survey': survey})

    # If there is no current set, render error message
    if not set:
        error_message = "No current set available to work with, try and start a new survey"
        return render(request, 'surveys/error.html', {'error_message': error_message, 'session':session, 'survey':survey})

    # if training counter not 0, choose another training
    if set.ntraining > 0:
        block = random.choice(set.blocks)
        trial = random.choice(block.trials)

    else:
        return redirect('surveys:survey-ready', survey_id=survey.id, session_key=session.key)

    context = {
        'session': session,
        'survey': survey,
        'language': language,
    }

    # decrease training counter
    set.ntraining = set.ntraining - 1

    # save set to pickle file
    try:
        with open('sessions/set_'+session.key, 'wb') as f:
            pickle.dump(set, f)
    except:
        return render(request, 'surveys/error.html', {'error_message':'Session not found, sorry', 'survey': survey})

    return render(request, 'surveys/training.html', context)

def save_training(request, survey_id, session_key):
    if request.method == 'POST':
        # try to open pickle file
        try:
            with open('sessions/set_'+ session_key, 'rb') as f:
                set = pickle.load(f)
        except:
            return render(request, 'surveys/error.html', {'error_message':'Session not found, sorry', 'survey': survey})

        # Try to save pickle file
        try:
            with open('sessions/set_'+session_key, 'wb') as f:
                pickle.dump(set, f)
        except:
            return render(request, 'surveys/error.html', {'error_message':'Session not found, sorry', 'survey': survey})

        return HttpResponse('success')

    return HttpResponse('fail')

def survey_ready(request, survey_id, session_key):
    survey = get_object_or_404(Survey, pk=survey_id)
    session = get_object_or_404(Session, key=session_key)

    #If session key is not current users session key, raise error
    if session.key != request.session.session_key:
        error_message = "Wrong session key"
        return render(request, 'surveys/error.html', {'error_message': error_message, 'session':session, 'survey':survey})

    # try to open set through picke file
    try:
        with open('sessions/set_'+session.key, 'rb') as f:
            set = pickle.load(f)
    except:
        return render(request, 'surveys/error.html', {'error_message':'Session not found, sorry', 'survey': survey})

    context = {
        'survey': survey,
        'session': session,
    }

    return render(request, 'surveys/survey_ready.html', context)

def trial(request, survey_id, session_key):
    survey = get_object_or_404(Survey, pk=survey_id)

surveys/templates/surveys/block_ready.html
{% extends 'base.html' %}
{% block body %}
{% load static %}
{% load i18n %}
<div class="uk-container uk-margin-top">
  <h2 class="uk-heading-small">{% trans "Ready" %}</h2>
  <p>{% trans "If you ready for the next set of situation click the Go-Button" %}</p>
  <a class="uk-button uk-button-default" href="{% url 'surveys:trial' survey.id session.key %}">{% trans "Go" %}</a>
  <img class="uk-float-right uk-visible@m" src="{% static 'surveys/img/shuffle.png'%}">
</div>
{% endblock %}

surveys/templates/surveys/error.html
{% extends 'base.html'%}
{% block body%}
<div class="uk-container uk-margin-top">
  <h1>Oops, something went wrong</h1>
  <p>{{error_message}}</p>
  <a class="uk-button uk-button-default" href="{% url 'home:index'  %}">Take me back home</a>
</div>
{% endblock %}

surveys/templates/surveys/instructions.html
{% extends 'base.html' %}
{% block body %}
{% load static %}
{% load i18n %}
{% get_current_language as LANGUAGE_CODE %}
<div class="uk-container uk-margin-top uk-animation-fade">
  <p>{{survey.ready|safe}}</p>
  <a class="uk-button uk-button-default uk-margin-bottom" href="{% url 'surveys:trial' survey.id session.key %}" uk-toggle>{% trans "Start Survey" %}</a>
  <img class="uk-float-right uk-visible@m" src="{% static 'surveys/img/process.png'%}">
</div>

<div class="hidden">
  <input id="trial-redirect" name="trial-redirect" type="hidden" value="{% url 'surveys:trial' survey.id session.key %}">
</div>

{% load static %}
<script src="{% static 'surveys/js/checkbox_validation.js' %}"></script>
{% endblock %}

surveys/templates/surveys/survey_detail.html
{% extends 'base.html'%}
{% block body%}
{% load static %}
<div class="uk-container uk-margin-top">
  <a href="{% url 'surveys:surveys' %}" uk-icon="icon: chevron-left" uk-tooltip="Back to overview"></a>
  <h2 class="uk-heading-small uk-heading-bullet">{{survey.name}}</h2>
  <p class="uk-article-meta">Created by <a href="#">{{survey.user}}</a> on {{survey.date_created}}.</p>
  <ul uk-tab>
    <li><a href="#">General Information</a></li>
    <li><a href="#">Redirects</a></li>
    <li><a href="#">Factors</a></li>
    <li><a href="#">Sessions</a></li>
    <li><a href="#">Statistics</a></li>
  </ul>
  <div class="uk-switcher">
    <div class="uk-animation-slide-bottom-small">
      <ul class="uk-iconnav">
        <li><a href="{% url 'surveys:edit-survey' survey.id %}" uk-tooltip="Edit general information" uk-icon="icon: file-edit"></a></li>
        <li><a href="#delete-modal" class="uk-disabled" uk-tooltip="Delete survey" uk-icon="icon: trash" uk-toggle></a></li>
      </ul>
      <div id="delete-modal" class="uk-flex-top" uk-modal>
        <div class="uk-modal-dialog uk-modal-body uk-margin-auto-vertical">
          <form action="{% url 'surveys:delete-survey' survey.id%}" method="post">
            {% csrf_token %}
            <h2 class="uk-modal-title">Delete survey</h2>
            <p>Do you really want to delete the survey?</p>
            <button class="uk-modal-close-default" type="button" uk-close></button>
            <p class="uk-text-right">
              <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
              <button class="uk-button uk-button-danger" type="submit">Delete</button>
            </p>
          </form>
        </div>
      </div>
      <h3>Description</h3>
      <hr>
      <p>{{survey.description}}</p>
      <h3>Introduction</h3>
      <hr>
      <p>{{survey.introduction|safe}}</p>
      <h3>Ready text</h3>
      <hr>
      <p>{{survey.ready|safe}}</p>
      <h3>End text</h3>
      <hr>
      <p>{{survey.end|safe}}</p>
    </div>
    <div class="uk-animation-slide-bottom-small">
      <h3>Redirects</h3>
      {% for redirect in survey.redirect_set.all %}
      <p>{{redirect.purpose}} <code>{{redirect.url}}</code></p>
      {% endfor %}
    </div>
    <div class="uk-animation-slide-bottom-small">
      <h3>Factors</h3>
      {% for setfactor in survey.setfactor_set.all %}
      <p class="uk-text-lead">{{setfactor}}</p>
      <ul class="uk-list uk-list-striped">
        {% for level in setfactor.setlevel_set.all %}
        <li>{{level.name}} <code>{{level.slug}}</code> <span class="uk-label uk-align-right"> {{level.value}}</span></li>
        {% endfor %}
      </ul>
      {% endfor %}
    </div>
    <div class="uk-animation-slide-bottom-small">
      <h3>Sessions</h3>
      {% if survey.session_set.all %}
      <button class="uk-button uk-button-danger" href="#" uk-toggle="target: #delete-session-modal" disabled>Delete all</button>
      {% endif %}
      <div id="delete-session-modal" uk-modal>
        <div class="uk-modal-dialog uk-modal-body">
          <form action="{% url 'surveys:delete-sessions' survey.id%}" method="post">
            {% csrf_token %}
            <h2 class="uk-modal-title">Delete sessions</h2>
            <p>Are you sure that you want to delete all the sessions?</p>
            <p class="uk-text-right">
              <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
              <button class="uk-button uk-button-danger" type="submit">Delete</button>
            </p>
          </form>
        </div>
      </div>
      <p>Number of sessions: <span class="uk-badge">{{survey.session_set.all.count}}</span></p>
      <table class="uk-table uk-table-divider">
        <thead>
          <tr>
            <th class="uk-table-shrink">#</th>
            <th class="uk-table-expand">Session ID</th>
            <th class="uk-width-small">Participant ID</th>
            <th class="uk-width-medium"></th>
          </tr>
        </thead>
        <tbody>
          {%for session in survey.session_set.all %}
          <tr>
            <td>{{forloop.counter}}</td>
            <td>{{session.key}}</td>
            <td><span class="uk-label">{{session.participantID}}</span></td>
            <td><a class="uk-button uk-button-default" href="{% url 'surveys:session' survey.id session.key%}">View details</a></td>
          </tr>
          {% endfor %}
        </tbody>
      </table>
    </div>
    <div class="uk-animation-slide-bottom-small">
      <input id="api-call-survey" name="api-call-survey" type="hidden" value="{% url 'api:api-surveys' survey.id %}">
      <div class="uk-column-1-2 uk-animation-slide-bottom-small ">
        <div>
          <p>Number of trials: <span class="uk-badge">{{ntrials}}</span></p>
        </div>
        <div>
          <canvas id="scenario_comparison" width="400" height="400"></canvas>
        </div>
      </div>
    </div>
  </div>
</div>
<script src="{% static 'surveys/js/survey_graphs.js' %}"></script>
{% endblock %}

surveys/templates/surveys/survey_list.html
{% extends 'base.html'%}
{% block body%}
<div class="uk-container uk-margin-top">
  <h2 class="uk-heading-small uk-heading-bullet">Survey list</h2>
  <ul class="uk-iconnav">
    <li><a href="{% url 'surveys:create-survey' %}" uk-icon="icon: plus" uk-tooltip="Create new survey"></a></li>
  </ul>
  <div class="uk-grid-large uk-child-width-1-3 uk-margin-top" uk-grid>
    {% for survey in survey_list %}
    <div class="uk-card uk-card-default uk-card-hover uk-margin-left">
      <div class="uk-card-header">
        <h3 class="uk-card-title">{{ survey.name }}</h3>
      </div>
      <div class="uk-card-body">
        <p>{{survey.description}}</p>
      </div>
      <div class="uk-card-footer">
        <a href="{% url 'surveys:survey' survey.id%}" class="uk-button uk-button-text">Details</a> |
        <a href="{% url 'surveys:introduction' survey.id%}" class="uk-button uk-button-text">Start Survey</a>
      </div>
    </div>
    {% endfor %}
  </div>
</div>
{% endblock %}

surveys/templates/surveys/survey_ready.html
{% extends 'base.html' %}
{% block body %}
{% load static %}
{% load i18n %}
<div class="uk-container uk-margin-top">
  <h2 class="uk-heading-small">{% trans "Results" %}</h2>
  <p>{% trans "Congratulations! You have finished the training round. Here are your results:" %}</p>
  <a class="uk-button uk-button-default" href="{% url 'surveys:trial' survey.id session.key %}">{% trans "Start real rounds!" %}</a>
  <img class="uk-float-right uk-visible@m" src="{% static 'surveys/img/results.png'%}">
</div>
{% endblock %}

surveys/templates/surveys/training.html
{% extends 'base.html' %}
{% block body %}
{% load static %}
{% load i18n %}
<div id="preload" class="uk-flex uk-height-medium uk-margin uk-text-center">
  <div class="uk-margin-auto uk-margin-auto-vertical uk-width-1-2@s">
    <div uk-spinner="ratio: 3">
    </div>
  </div>
</div>
<div class="content">
    <div class="uk-visible@m">
      <div class="uk-flex uk-flex-center">
        <div id="offcanvas-reveal" uk-offcanvas="mode: reveal; overlay: true">
          <div class="uk-offcanvas-bar">
            <button class="uk-offcanvas-close" type="button" uk-close></button>
            <h3>Trial Details</h3>
            <p>Attemps: <span class="uk-badge">{{attempts}}</span></p>
            <p>Blocknumber: <span class="uk-badge">{{blockcounter}}</span></p>
            <p>Blocksize: <span class="uk-badge">{{size}}</span></p>
          </div>
        </div>
      </div>
    </div>
</div>
<div class="hidden">
  <input id="sessionkey" name="sessionkey" type="hidden" value="{{ session.key }}">
  <input id="blockcounter" name="blockcounter" type="hidden" value="{{ blockcounter }}">
  <input id="trial-id" name="trial-id" type="hidden" value="{{ trial.id }}">
  <input id="language-code" name="language-code" type="hidden" value="{{language}}">
  <input id="save-training" name="save-training" type="hidden" value="{% url 'surveys:save-training' survey.id session.key %}">
  <input id="next-training" name="next-training" type="hidden" value="{% url 'surveys:training' survey.id session.key %}">
</div>
{% load static %}
<script src="{% static 'surveys/js/training.js' %}"></script>
{% endblock %}

surveys/templates/surveys/trial.html
{% extends 'base.html' %}
{% block body %}
{% load static %}
{% load i18n %}

<div id="preload" class="uk-flex uk-height-medium uk-margin uk-text-center">
  <div class="uk-margin-auto uk-margin-auto-vertical uk-width-1-2@s">
    <div uk-spinner="ratio: 3">
    </div>
  </div>
</div>
<div class="content uk-container uk-margin">
  <!-- Enter here you factor or lavel name -->
  <h3>Factor combination:</h3>{{trial.factor1.name}}
  <p><a class="uk-button uk-button-default uk-margin-bottom" href="{% url 'surveys:save-trial' survey.id session.key db_trial.id %}" uk-toggle>{% trans "Next Trial" %}</a></p>

</div>
<div class="hidden">
  <input id="sessionkey" name="sessionkey" type="hidden" value="{{ session.key }}">
  <input id="blockcounter" name="blockcounter" type="hidden" value="{{ blockcounter }}">
  <input id="trial-id" name="trial-id" type="hidden" value="{{ trial.id }}">
  <input id="language-code" name="language-code" type="hidden" value="{{language}}">
  <input id="next-trial" name="next-trial" type="hidden" value="{% url 'surveys:trial' survey.id session.key %}">
</div>
{% load static %}
<script src="{% static 'surveys/js/save_trial.js' %}"></script>
{% endblock %}